lowp vec4 desaturate(lowp vec4 c)
{
	if(length(c.rgb) == 0.0) // avoid alpha channel dep. color channel
		return c;
	
	lowp float a = c.a;
	c.a = dot (c.rgb, vec3(0.299, 0.587, 0.114));
	
#ifdef SAMSUNG_I9000
	c.rgb = mix(c.rgb, c.aaa, 0.25);
#elif defined(SAMSUNG_I9100)
	c.rgb = mix(c.rgb, c.aaa, 0.15);
	c.b *= 1.1;
	c.r *= 1.12;
	c.rgb = mix(c.rgb, vec3(1.0, 1.0, 1.0), 0.23);
#else
	c.rgb = mix(c.rgb, c.aaa, 0.375);
#endif
	
	return vec4(c.rgb, a);
}